/************************************************************************
Privacy For Pictures pfp.c  v 0.02 20.10.99
please report any bug to: klee@informatik.unibw-muenchen.de
*************************************************************************/
/************************************************************************
DOS version:      compile with gcc
WINDOWS 95/98/NT: compile with MS Visual C++
*************************************************************************/

/* #define DEBUG 0 */

#define NPICT (1000)     /* Number of pictures you can go back */
#define HBMP  (1024*2)   /* must be a multiple of 16 */
#define VBMP  (768*2)    /* must be a multiple of 16 */
/*unsigned char bgr[3*HBMP*VBMP]; declared in dos.c or win.c */
 
int hdim, vdim; 
int pictnr=0;
int jsize,joffset,jpos,decrypt=0;
unsigned char passwd[80],dat[8];
unsigned int key[52],key22,key28;
char filename[100];
char *head="pfp v0.02 IDEA encrypted file \015\012";

#include <stdio.h>
/*#include "dos.c"*/   /* DOS version */
#include "win.c"       /* WIN version */


int pictpos[NPICT+5]={0};
int hmax, vmax, hunits, vunits; 
int htab[4][1024];
int qtab[4][64];
int tab_h[256], tab_v[256], tab_q[256];
int lastbyte=0, nextbyte1=0, nextbyte2=0, bitsinlastbyte=0;
int mask[17]={0x0,0x1,0x3,0x7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
              0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff,0xffff};
#define lmt 256
unsigned char limit[256+lmt+lmt];
int symb0[1]={0},symb1[2],symb2[4],symb3[8],symb4[16],symb5[32],
    symb6[64],symb7[128],symb8[256],symb9[512],symb10[1024],symb11[2048];
int *symb[12]={symb0,symb1,symb2,symb3,symb4,symb5,symb6,symb7,
               symb8,symb9,symb10,symb11};

#include "fft.c"
int *fft_i4;

FILE *txt=NULL, *jpg=NULL, *fopen(), *fopenb();


/***********************************************************************/

void setpict(i) int i;
{int j,k;
 if ((pictnr=i)>NPICT)pictnr=NPICT;
 if (pictnr<0) pictnr=0;
#ifdef DEBUG
 out_string("set picture Nr.:"); out_hex2(i);
 out_string("  use Nr.:"); out_hex2(pictnr);
 out_string("  filepos:"); out_hex2(pictpos[pictnr]);
 out_string("\015\012");
#endif
 if (decrypt)
    {j=pictpos[pictnr];
     jpos=j&0xfffffff8;
     fseek(jpg,joffset+jpos,SEEK_SET);
     k=(jpos>>3)+key22;
     key[22]=k&0xffff;
     key[28]=(key28+(k>>16))&0xffff;
     j=j&0x07;
     for (k=0;k<j;k++) getC();
    }
    else  fseek(jpg,pictpos[pictnr],SEEK_SET);
 nextbyte1=nextbyte2=0; get_byte(); get_byte();
}

void init()
{int i,j,k,l;
 char *p;
#ifdef DEBUG
 txt = fopen("pfp.log","wb"); if (txt==NULL) ende(1,0);
 out_string("Picture file: ");out_string(filename);out_string("\15\12\15\12");
#endif
 jpg = fopen(filename,"rb"); if (jpg==NULL) ende(2,1); 
 tryagain:
 p=head;  while (*p && (*p == getc(jpg))) p++;
 if (! *p)  
    {get_passwd();
#ifdef DEBUG
 out_string("password: "); out_string(passwd); out_string("\015\012");
#endif
     for (i=0;i<8; i++) key[i] =   ((passwd[3*i  ]&0x3f)<<10)
                                  + ((passwd[3*i+1]&0x1f)<< 5)
                                  + ((passwd[3*i+2]&0x1f)    );
     for (i=8;i<52;i++) key[i] = ((key[(i+1)%8?i-7:i-15]<<9) |
                                  (key[(i+2)%8<2?i-14:i-6]>>7))&0xffff; 

     for (i=0;i<52;i++) key[i] = key[i] ^ 0x0dae;  /* avoid week keys */
     decrypt=1; jpos=0; jsize=16; j=0;
     for (i=0;i<8;i++) if (i!=getC()){fseek(jpg,0,0); goto tryagain;}
     for (i=0;i<8;i++) j=(j<<8)+getC();
     jsize=j;
     joffset=ftell(jpg); jpos=0; key22=key[22]; key28=key[28];
#ifdef DEBUG
 out_string("size: "); out_dec(jsize);
 out_string("\015\012offset:"); out_dec(joffset);
 out_string("\015\012");
#endif
    } 

 else fseek(jpg,0,0);   

 get_byte(); get_byte();


j=-1;
for (i=1; i<12; i++)
    {l=(1<<(i-1));
     for (k=0; k<l; k++) symb[i][k]=j++;
     j=-j+1;
     for (k=l; k<2*l; k++) symb[i][k]=j++;
     j=-(j*2-1);
    }

j=0;
for (i=0;i<lmt;i++) limit[j++]=0;
for (i=0;i<255;i++) limit[j++]=i;
for (i=0;i<lmt;i++) limit[j++]=255;
}

void cleanup()
{
 fclose(jpg);
 if (txt) fclose(txt);
}

int decode()
{int i;
#ifdef DEBUG
 out_string("decoding pictur Nr.:"); out_hex2(pictnr);
 out_string("\015\012");
#endif
 if (nextbyte1 == EOF) return (-1);
 while (nextbyte1 != EOF)
 {switch (i=get_word())
   {case 0xffd8: SOI(); break;
    case 0xffd9: EOI(); break;
    case 0xffdb: DQT(); break;
    case 0xffc4: DHT(); break;
    case 0xffc0: SOF(); break;
    case 0xffda: SOS(); 
         if (pictnr<NPICT)
            {if (decrypt)
                {pictpos[++pictnr]=jpos-2;
                }             
                else pictpos[++pictnr]=ftell(jpg)-2; 
            }
         return (0);
         
    case 0xffe0: APP0();break;
    case 0xfffe: COM(); break;
    default: UNKNOWN(i);
   } 
 }
}


void SOI()
{
#ifdef DEBUG
 out_string("START OF IMAGE\015\012\015\012");
#endif
}

void EOI()
{int i;
#ifdef DEBUG
 out_string("END OF IMAGE\015\012");
#endif

#ifdef DEBUG
    if ((nextbyte1==0xff && nextbyte2==0xd8) || nextbyte1==EOF) return;
    out_string("start skip extra bytes in file:\015\012");
#endif
 while (nextbyte1 != EOF) 
    {if (nextbyte1==0xff && nextbyte2==0xd8) return;
     i=get_byte();
#ifdef DEBUG
     out_hex1(i);
#endif
    }
#ifdef DEBUG
 out_string("\015\012end skip extra bytes in file\015\012");
#endif
}

void DQT()
{int i,j,k;
 i=get_word()-2;
 while (i)
  {if (i<65) ende(3,2);
   j=get_byte();
   if (j>3) ende(4,2);
   for (k=0;k<64;k++) {qtab[j][k]=(get_byte());}
   i=i-65;
  }
#ifdef DEBUG
 out_string("QUANTISATION TABLE Nr.: ");
 out_hex1(j); out_string("\015\012");
#endif
}


/**********************************************************
a[i]: 0000xxyy
xx: Anzahl der Stellen
yy: Wert

a[i]: -(00xxyyyy)
yyyy: Index in a[] fuer Subtabelle
xx:   2**xx = Groesse der Subtabelle

**********************************************************/


void DHT()
{int i,j,k,l,m,n,n1,n2,rest;
 int nlang[16];
 int *ht;
 
 rest=get_word()-2;
 if (rest<0) ende(5,3);
 while(rest)
 {rest=rest-17;
  if (rest<0) ende(6,3);
  j=get_byte();
#ifdef DEBUG
 out_string("HUFFMANN TABLE Nr.: "); out_hex1(j); out_string("\015\012");
#endif

  if      (j==0x00) ht=htab[0]; /* DC table 0 */
  else if (j==0x01) ht=htab[1]; /* DC table 1 */
  else if (j==0x10) ht=htab[2]; /* AC table 0 */
  else if (j==0x11) ht=htab[3]; /* AC table 1 */
  else ende(7,3);
    
  for (j=0;j<16;j++) {nlang[j]=get_byte(); rest=rest-nlang[j];}
  if (rest<0) ende (5,3);

  n=0;  n2=256;  m=16; l=-1;
  for (i=0;i<16;i++)
   {m=(m-1);
    for (j=0;j<nlang[i];j++)
    {if (i>7) {k=n>>8;
               if (k!=l) {l=k; n1=n2;}
               ht[k] = -( ((8-m)<<16)+n1 );
               n2=n1 + ( 1<<(8-m) );
              }
     n=n+(1<<m);
    }
   }

  n=0;
  m=0x10000;
  for (i=0;i<16;i++)
   {m=(m>>1);
    for (j=0;j<nlang[i];j++)
    {k=get_byte();
     if (i<8) {for (l=n>>8; l<(n+m)>>8; l++) ht[l]=((i+1)<<8)+k;}
         else {n1=(-ht[n>>8])>>16; n2=(-ht[n>>8])&0xffff; 
               for (l=0; l < (m>>(8-n1));l++)
                    ht[n2 + ( (n&0xff)>>(8-n1) ) + l]= ((i+1)<<8)+k;
              }
     n=n+m;
    }
   }
  }
}

void SOF()
{int i,j,k,l;
#ifdef DEBUG
 out_string("START OF FRAME BASELINE DCT: ");
#endif
 i=get_word()-8;
 if (i<0) ende(8,4);
 if ((j=get_byte())!=8) ende(9,4); 
 vdim=get_word(); hdim=get_word();
#ifdef DEBUG
 out_string("size: "); out_dec(hdim);
 out_string(" x "); out_dec(vdim);
 out_string("\015\012");
#endif
 if (vdim>VBMP || hdim>HBMP) ende(10,5);
 j=get_byte();
 if (i!=(j*3)) ende(11,4);
 hmax=1; vmax=1;
 for (i=0;i<j;i++)
   {k=get_byte(); l=get_byte();
    tab_h[k]=l>>4; tab_v[k]=l&0x0f; tab_q[k]=get_byte();
    if (tab_h[k]>hmax) hmax=tab_h[k];
    if (tab_v[k]>vmax) vmax=tab_v[k];
    if (tab_h[k]<1 || tab_h[k]>4 || tab_v[k]<1 || tab_v[k]>4) ende(12,4);
   }
 hunits= (((hdim+7)/8)+hmax-1)/hmax;
 vunits= (((vdim+7)/8)+vmax-1)/vmax;
}

#define next8bits  ((((lastbyte<<8) + (nextbyte1&0xff)) >> bitsinlastbyte) & 0xff)

void SOS()
{int i,j,k,n;
 int i1,i2,i3,i4,i5,k1,k2,n1,n2,n3;
 int komp_n, komp_h[4], komp_v[4], komp_q[4], komp_c[2][4], komp_dc[4];
 int typ;
 int a[16][64];
 int *b;

#ifdef DEBUG
 out_string("START OF SCAN:\015\012");
#endif
 if ( (i=get_word()-6) < 0 ) ende(13,6);
 if ( (komp_n=get_byte()) > 4 ) ende(14,6);
 if (i!=(komp_n*2)) ende(15,6);
 for (i=0;i<komp_n;i++)
   {j=get_byte();
    komp_h[i]=tab_h[j]; komp_v[i]=tab_v[j]; komp_q[i]=tab_q[j]; 
    komp_dc[i]=0;
    j=get_byte(); komp_c[0][i]=j>>4; komp_c[1][i]=2+(j&0x0f);
    if (komp_h[i]!=1 && komp_h[i]!=2) ende(16,7);
    if (komp_v[i]!=1 && komp_v[i]!=2) ende(17,7);
    if (komp_q[i] <0 || komp_q[i]> 3) ende(18,7);
    if (komp_c[0][i]!=0 && komp_c[0][i]!=1) ende(19,7);
    if (komp_c[1][i]!=2 && komp_c[1][i]!=3) ende(20,7);
   }
 if (get_byte()!=0) ende(21,7); 
 if (get_byte()!=63) ende(22,7); 
 if (get_byte()!=0) ende(23,7); 

#ifdef DEBUG
 out_string("Komponenten: "); out_hex1(komp_n); out_string("\015\012");
 for (i=0; i<komp_n; i++)
  {out_hex1(i); out_string("  h: "); out_hex1(komp_h[i]);
   out_string("   v: "); out_hex1(komp_v[i]); out_string("\015\012");
  }
#endif


 if (komp_h[0] != hmax || komp_v[0] != vmax) ende (4,7);

 if      (komp_n==1) typ=0;
 else if (komp_n==3)
         {if      (komp_h[0]==1 && komp_v[0]==1 && 
                   komp_h[1]==1 && komp_v[1]==1 && 
                   komp_h[2]==1 && komp_v[2]==1   ) typ=1;
          else if (komp_h[0]==2 && komp_v[0]==1 && 
                   komp_h[1]==1 && komp_v[1]==1 && 
                   komp_h[2]==1 && komp_v[2]==1   ) typ=2;
          else if (komp_h[0]==2 && komp_v[0]==2 && 
                   komp_h[1]==1 && komp_v[1]==1 && 
                   komp_h[2]==1 && komp_v[2]==1   ) typ=3;
          else ende (3,7);
         
         }
 else    ende(24,7);
 

 for (k1=0; k1<vunits; k1++)
 for (k2=0; k2<hunits; k2++)
   {if (nextbyte1==0xff && nextbyte2>=0xd0 && nextbyte2<=0xd7) 
       {nextbyte1=getC(); nextbyte2=getC(); bitsinlastbyte=0;
        for (i=0;i<komp_n;i++) komp_dc[i]=0;
       }    
    i5=0;
    for (i1=0; i1<komp_n    ; i1++)
    for (i2=0; i2<komp_v[i1]; i2++)
    for (i3=0; i3<komp_h[i1]; i3++)
      {j=0; i4=1; b=a[i5++];
       do
       {if ( (i=htab[komp_c[j][i1]][next8bits]) < 0)
         {get_bits(8);
          i=htab[komp_c[j][i1]][((-i)&0xffff)+(next8bits>>(8-((-i)>>16)))]-0x800;
         }
        get_bits(i>>8);
        i=i&0xff;

        if (!j)
           {komp_dc[i1] += symb[i][get_bits(i)];
            k=komp_dc[i1]*qtab[komp_q[i1]][0];
            /* for (n=0; n<64; n++) b[n]=k*fft[0][n]; */
            fft_i4=fft[0];
            n=0;
            b[n] = k*fft_i4[n]; n++; /* 0*/
            b[n] = k*fft_i4[n]; n++; /* 1*/
            b[n] = k*fft_i4[n]; n++; /* 2*/
            b[n] = k*fft_i4[n]; n++; /* 3*/
            b[n] = k*fft_i4[n]; n++; /* 4*/
            b[n] = k*fft_i4[n]; n++; /* 5*/
            b[n] = k*fft_i4[n]; n++; /* 6*/
            b[n] = k*fft_i4[n]; n++; /* 7*/
            b[n] = k*fft_i4[n]; n++; /* 8*/
            b[n] = k*fft_i4[n]; n++; /* 9*/
            b[n] = k*fft_i4[n]; n++; /*10*/
            b[n] = k*fft_i4[n]; n++; /*11*/
            b[n] = k*fft_i4[n]; n++; /*12*/
            b[n] = k*fft_i4[n]; n++; /*13*/
            b[n] = k*fft_i4[n]; n++; /*14*/
            b[n] = k*fft_i4[n]; n++; /*15*/
            b[n] = k*fft_i4[n]; n++; /*16*/
            b[n] = k*fft_i4[n]; n++; /*17*/
            b[n] = k*fft_i4[n]; n++; /*18*/
            b[n] = k*fft_i4[n]; n++; /*19*/
            b[n] = k*fft_i4[n]; n++; /*20*/
            b[n] = k*fft_i4[n]; n++; /*21*/
            b[n] = k*fft_i4[n]; n++; /*22*/
            b[n] = k*fft_i4[n]; n++; /*23*/
            b[n] = k*fft_i4[n]; n++; /*24*/
            b[n] = k*fft_i4[n]; n++; /*25*/
            b[n] = k*fft_i4[n]; n++; /*26*/
            b[n] = k*fft_i4[n]; n++; /*27*/
            b[n] = k*fft_i4[n]; n++; /*28*/
            b[n] = k*fft_i4[n]; n++; /*29*/
            b[n] = k*fft_i4[n]; n++; /*30*/
            b[n] = k*fft_i4[n]; n++; /*31*/
            b[n] = k*fft_i4[n]; n++; /*32*/
            b[n] = k*fft_i4[n]; n++; /*33*/
            b[n] = k*fft_i4[n]; n++; /*34*/
            b[n] = k*fft_i4[n]; n++; /*35*/
            b[n] = k*fft_i4[n]; n++; /*36*/
            b[n] = k*fft_i4[n]; n++; /*37*/
            b[n] = k*fft_i4[n]; n++; /*38*/
            b[n] = k*fft_i4[n]; n++; /*39*/
            b[n] = k*fft_i4[n]; n++; /*40*/
            b[n] = k*fft_i4[n]; n++; /*41*/
            b[n] = k*fft_i4[n]; n++; /*42*/
            b[n] = k*fft_i4[n]; n++; /*43*/
            b[n] = k*fft_i4[n]; n++; /*44*/
            b[n] = k*fft_i4[n]; n++; /*45*/
            b[n] = k*fft_i4[n]; n++; /*46*/
            b[n] = k*fft_i4[n]; n++; /*47*/
            b[n] = k*fft_i4[n]; n++; /*48*/
            b[n] = k*fft_i4[n]; n++; /*49*/
            b[n] = k*fft_i4[n]; n++; /*50*/
            b[n] = k*fft_i4[n]; n++; /*51*/
            b[n] = k*fft_i4[n]; n++; /*52*/
            b[n] = k*fft_i4[n]; n++; /*53*/
            b[n] = k*fft_i4[n]; n++; /*54*/
            b[n] = k*fft_i4[n]; n++; /*55*/
            b[n] = k*fft_i4[n]; n++; /*56*/
            b[n] = k*fft_i4[n]; n++; /*57*/
            b[n] = k*fft_i4[n]; n++; /*58*/
            b[n] = k*fft_i4[n]; n++; /*59*/
            b[n] = k*fft_i4[n]; n++; /*60*/
            b[n] = k*fft_i4[n]; n++; /*61*/
            b[n] = k*fft_i4[n]; n++; /*62*/
            b[n] = k*fft_i4[n];      /*63*/

            j=1;
           } 
        else
           {if      (i==0x00) i4=64;
            else if (i==0xf0) i4=i4+16;
            else {i4=i4+(i>>4);
                  i=i&0x0f;
                  k=symb[i][get_bits(i)]*qtab[komp_q[i1]][i4];
                  /* for (n=0; n<64; n++) b[n] += k*fft[i4][n]; */
                  fft_i4=fft[i4];
                  n=0;
                  b[n] += k*fft_i4[n]; n++; /* 0*/
                  b[n] += k*fft_i4[n]; n++; /* 1*/
                  b[n] += k*fft_i4[n]; n++; /* 2*/
                  b[n] += k*fft_i4[n]; n++; /* 3*/
                  b[n] += k*fft_i4[n]; n++; /* 4*/
                  b[n] += k*fft_i4[n]; n++; /* 5*/
                  b[n] += k*fft_i4[n]; n++; /* 6*/
                  b[n] += k*fft_i4[n]; n++; /* 7*/
                  b[n] += k*fft_i4[n]; n++; /* 8*/
                  b[n] += k*fft_i4[n]; n++; /* 9*/
                  b[n] += k*fft_i4[n]; n++; /*10*/
                  b[n] += k*fft_i4[n]; n++; /*11*/
                  b[n] += k*fft_i4[n]; n++; /*12*/
                  b[n] += k*fft_i4[n]; n++; /*13*/
                  b[n] += k*fft_i4[n]; n++; /*14*/
                  b[n] += k*fft_i4[n]; n++; /*15*/
                  b[n] += k*fft_i4[n]; n++; /*16*/
                  b[n] += k*fft_i4[n]; n++; /*17*/
                  b[n] += k*fft_i4[n]; n++; /*18*/
                  b[n] += k*fft_i4[n]; n++; /*19*/
                  b[n] += k*fft_i4[n]; n++; /*20*/
                  b[n] += k*fft_i4[n]; n++; /*21*/
                  b[n] += k*fft_i4[n]; n++; /*22*/
                  b[n] += k*fft_i4[n]; n++; /*23*/
                  b[n] += k*fft_i4[n]; n++; /*24*/
                  b[n] += k*fft_i4[n]; n++; /*25*/
                  b[n] += k*fft_i4[n]; n++; /*26*/
                  b[n] += k*fft_i4[n]; n++; /*27*/
                  b[n] += k*fft_i4[n]; n++; /*28*/
                  b[n] += k*fft_i4[n]; n++; /*29*/
                  b[n] += k*fft_i4[n]; n++; /*30*/
                  b[n] += k*fft_i4[n]; n++; /*31*/
                  b[n] += k*fft_i4[n]; n++; /*32*/
                  b[n] += k*fft_i4[n]; n++; /*33*/
                  b[n] += k*fft_i4[n]; n++; /*34*/
                  b[n] += k*fft_i4[n]; n++; /*35*/
                  b[n] += k*fft_i4[n]; n++; /*36*/
                  b[n] += k*fft_i4[n]; n++; /*37*/
                  b[n] += k*fft_i4[n]; n++; /*38*/
                  b[n] += k*fft_i4[n]; n++; /*39*/
                  b[n] += k*fft_i4[n]; n++; /*40*/
                  b[n] += k*fft_i4[n]; n++; /*41*/
                  b[n] += k*fft_i4[n]; n++; /*42*/
                  b[n] += k*fft_i4[n]; n++; /*43*/
                  b[n] += k*fft_i4[n]; n++; /*44*/
                  b[n] += k*fft_i4[n]; n++; /*45*/
                  b[n] += k*fft_i4[n]; n++; /*46*/
                  b[n] += k*fft_i4[n]; n++; /*47*/
                  b[n] += k*fft_i4[n]; n++; /*48*/
                  b[n] += k*fft_i4[n]; n++; /*49*/
                  b[n] += k*fft_i4[n]; n++; /*50*/
                  b[n] += k*fft_i4[n]; n++; /*51*/
                  b[n] += k*fft_i4[n]; n++; /*52*/
                  b[n] += k*fft_i4[n]; n++; /*53*/
                  b[n] += k*fft_i4[n]; n++; /*54*/
                  b[n] += k*fft_i4[n]; n++; /*55*/
                  b[n] += k*fft_i4[n]; n++; /*56*/
                  b[n] += k*fft_i4[n]; n++; /*57*/
                  b[n] += k*fft_i4[n]; n++; /*58*/
                  b[n] += k*fft_i4[n]; n++; /*59*/
                  b[n] += k*fft_i4[n]; n++; /*60*/
                  b[n] += k*fft_i4[n]; n++; /*61*/
                  b[n] += k*fft_i4[n]; n++; /*62*/
                  b[n] += k*fft_i4[n];      /*63*/

                  i4++;
                 }
           }
       } while (i4<64);
      }     

      n3=3*(k1*vmax*8*HBMP+((k2*hmax)<<3));

      switch (typ)
       {case 0: 
          n1=0;
          for (i1=0; i1<8; i1++)
           {for (i2=0; i2<8; i2++)
             {bgr[n3++]=limit[((a[0][n1])>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1])>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1])>>16)+128+lmt];
              n1++;
             }
            n3=n3+(HBMP-8)*3;
           }
          break;

        case 1:
          for (i=0;i<64;i++) {a[1][i]=a[1][i]>>12; a[2][i]=a[2][i]>>12;}
          n1=0;
          for (i1=0; i1<8; i1++)
           {for (i2=0; i2<8; i2++)
             {bgr[n3++]=limit[((a[0][n1]+a[1][n1]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1]-a[1][n1]*1410-a[2][n1]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1]+a[2][n1]*5743)>>16)+128+lmt];
              n1++;
             }
            n3=n3+(HBMP-8)*3;
           }
          break;

        case 2:
          for (i=0;i<64;i++) {a[2][i]=a[2][i]>>12; a[3][i]=a[3][i]>>12;}
          n1=0; n2=0;
          for (i1=0; i1<8; i1++)
           {for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[0][n1  ]+a[2][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1  ]-a[2][n2]*1410-a[3][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1++]+a[3][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[0][n1  ]+a[2][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1  ]-a[2][n2]*1410-a[3][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1++]+a[3][n2++]*5743)>>16)+128+lmt];
             }
            n1=n1-8;
            for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[1][n1  ]+a[2][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1  ]-a[2][n2]*1410-a[3][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1++]+a[3][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[1][n1  ]+a[2][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1  ]-a[2][n2]*1410-a[3][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1++]+a[3][n2++]*5743)>>16)+128+lmt];
             }
            n3=n3+(HBMP-16)*3;
           }
          break;

        case 3:
          for (i=0;i<64;i++) {a[4][i]=a[4][i]>>12; a[5][i]=a[5][i]>>12;}
          n1=0; n2=0;
          for (i1=0; i1<32; i1=i1+4)
           {n2=i1&0xf8;
            for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[0][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1++]+a[5][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[0][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[0][n1++]+a[5][n2++]*5743)>>16)+128+lmt];
             }
            n1=n1-8;
            for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[1][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1++]+a[5][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[1][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[1][n1++]+a[5][n2++]*5743)>>16)+128+lmt];
             }
            n3=n3+(HBMP-16)*3;
           }

          n1=0;
          for (i1=32; i1<64; i1=i1+4)
           {n2=i1&0xf8;
            for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[2][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[2][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[2][n1++]+a[5][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[2][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[2][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[2][n1++]+a[5][n2++]*5743)>>16)+128+lmt];
             }
            n1=n1-8;
            for (i2=0; i2<4; i2++)
             {bgr[n3++]=limit[((a[3][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[3][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[3][n1++]+a[5][n2]*5743)>>16)+128+lmt];
              
              bgr[n3++]=limit[((a[3][n1  ]+a[4][n2]*7258)>>16)+128+lmt];
              bgr[n3++]=limit[((a[3][n1  ]-a[4][n2]*1410-a[5][n2]*2925)>>16)+128+lmt];
              bgr[n3++]=limit[((a[3][n1++]+a[5][n2++]*5743)>>16)+128+lmt];
             }
            n3=n3+(HBMP-16)*3;
           }
          break; 
        default: ende(25,7);
       }
   }
}

void APP0()
{int i,j,k;
#ifdef DEBUG
 out_string("APP0:\015\012");
#endif
 i=get_word();
 for (j=0;j<i-2;j++) 
     {k=get_byte();
#ifdef DEBUG
      out_byte(k);
#endif
     }
#ifdef DEBUG
 out_string("\015\012\015\012");
#endif
}

void COM()
{int i,j,k;
#ifdef DEBUG
 out_string("COMMENT:\015\012");
#endif
 i=get_word();
 for (j=0;j<i-2;j++) 
     {k=get_byte();
#ifdef DEBUG
      out_byte(k);
#endif
     }
#ifdef DEBUG
 out_string("\015\012\015\012");
#endif
}

void UNKNOWN(n) int n;
{int i,j,k;
#ifdef DEBUG
 out_string("unimplemented tag: ");
 out_hex2(n);
 out_string(" :\015\012");
#endif

if (n>=0xffc0 && n<0xffff)
   {i=get_word();
    for (j=0;j<i-2;j++) 
        {k=get_byte();
#ifdef DEBUG
         out_hex1(k);
#endif
        }
#ifdef DEBUG
    out_string("\015\012end unimplemented tag\015\012");
#endif
   }
else
   {
#ifdef DEBUG
    if (nextbyte1==0xff && nextbyte2==0xd8) return;
    out_string("skip unknown bytes in file:\015\012");
#endif
    while (nextbyte1 != EOF) 
       {if (nextbyte1==0xff && nextbyte2==0xd8) return;
        i=get_byte();
#ifdef DEBUG
        out_hex1(i);
#endif
       }
#ifdef DEBUG
    out_string("\015\012end skip unknown bytes in file\015\012");
#endif
   }
}

int get_bits(i) int i;
{int k;
 if (!i) return 0;

 if (i<=bitsinlastbyte)
    {
     bitsinlastbyte=bitsinlastbyte-i;
     return ((lastbyte>>bitsinlastbyte) & mask[i]);
    }

 if (i<=bitsinlastbyte+8)
    {
     k = (lastbyte<<8) + nextbyte1;
     lastbyte=nextbyte1; nextbyte1=nextbyte2; nextbyte2=getC();
     if (lastbyte==EOF) ende(26,8); 
     if (lastbyte==0xff) {if (nextbyte1!=0) ende(27,6); 
                          nextbyte1=nextbyte2;
                          nextbyte2=getC();
                         }
     bitsinlastbyte=bitsinlastbyte+8-i;
     return ((k>>bitsinlastbyte) & mask[i]);
    }

 if (i>16) ende(28,6);

    {
     k = (lastbyte<<8) + nextbyte1;
     lastbyte=nextbyte1; nextbyte1=nextbyte2; nextbyte2=getC();
     if (lastbyte==EOF) ende(29,8); 
     if (lastbyte==0xff) {if (nextbyte1!=0) ende(30,6); 
                          nextbyte1=nextbyte2;
                          nextbyte2=getC();
                         }
     k = (k<<8) + nextbyte1;
     lastbyte=nextbyte1; nextbyte1=nextbyte2; nextbyte2=getC();
     if (lastbyte==EOF) ende(31,8); 
     if (lastbyte==0xff) {if (nextbyte1!=0) ende(32,6); 
                          nextbyte1=nextbyte2;
                          nextbyte2=getC();
                         }
     bitsinlastbyte=bitsinlastbyte+16-i;
     return ((k>>bitsinlastbyte) & mask[i]);
    }
}

    
int get_word()
{int i,j;
 if ( (i=get_byte())==EOF) ende(33,8); 
 if ( (j=get_byte())==EOF) ende(34,8); 
 return (i<<8) + j;
}


int get_byte()
{lastbyte=nextbyte1; nextbyte1=nextbyte2; nextbyte2=getC(); 
 if (lastbyte==EOF) ende(35,8); 
 bitsinlastbyte=0;
 return lastbyte;
}

int getC()
{int i,j;
 if (decrypt)
    {
     if (jpos>=jsize) return EOF;
     if (!(i=(jpos++)&0x07))
        {for (j=0;j<8;j++) dat[j]=getc(jpg);
         crypt(dat,key);
         /* modify the key after any 64 bit decryption */
         if (!(key[22]=(key[22]+1)&0xffff)) key[28]=(key[28]+1)&0xffff;
        }
      return dat[i];
    }
    else return getc(jpg);
}


#define mul(x,y) (z1=(x)*(y))?((z2=z1&0xffff)>=(z3=(z1>>16))?(z2-z3)&0xffff:(z2-z3+1)&0xffff):((1-(x)-(y))&0xffff)

void crypt(p,q) unsigned char *p; unsigned int *q;
{unsigned int i,i1,i2,i22,i3,i4,i5,i6,z1,z2,z3;
 i1=(*p++)<<8; i1 += *p++;
 i2=(*p++)<<8; i2 += *p++;
 i3=(*p++)<<8; i3 += *p++;
 i4=(*p++)<<8; i4 += *p;
 for (i=0; i<8; i++)
     {i1 = mul(i1,*q); q++; 
      i22= (i2 + *q++)&0xffff;
      i3 = (i3 + *q++)&0xffff;
      i4 = mul(i4,*q); q++;
      i5 = mul(i1^i3,*q); q++;
      i6 = mul( ((i22^i4)+i5)&0xffff,*q); q++;
      i5 = (i5+i6)&0xffff;
      i1 = i1^i6;
      i2 = i3^i6;
      i3 = i22^i5;
      i4 = i4^i5;
     }
 i1 = mul(i1,*q); q++;
 i22= (i3 + *q++)&0xffff;
 i3 = (i2 + *q++)&0xffff;
 i4 = mul(i4,*q); q++;
 *p-- = i4;
 *p-- = i4>>8;
 *p-- = i3;
 *p-- = i3>>8;
 *p-- = i22;
 *p-- = i22>>8;
 *p-- = i1;
 *p   = i1>>8;
}


void out_byte(i)   int i; {static int spalte=0;
                           if (!txt) return;
                           putc(i,txt); 
                           if (i==0x0a) spalte=-1;
                           if(++spalte>71) 
                             {spalte=0; putc('\015',txt); putc('\012',txt);}
                          }
void out_bin(i,n)  int i,n; {int j; for (j=0;j<16-n;j++) out_byte(' ');
                   j=(1<<n); while (j){if (i&j) out_byte('1'); 
                   else out_byte('0'); j=(j>>1);}}
void out_hex1(i)   int i; { static char hex[] = {'0','1','2','3','4','5',
                   '6','7','8','9','a','b','c','d','e','f'}; 
                   out_byte(hex[(i>>4)&15]); out_byte(hex[i&15]);}
void out_hex2(i)   int i; {out_hex1(i>>8); out_hex1(i&0xff);}
void out_hex4(i)   int i; {out_hex2(i>>16); out_hex2(i&0xffff);}
void out_dec(i)    int i; {int k,j=1; if (i<0) {out_byte('-'); i = -i;}
                   k=i; while (k /= 10) j *= 10; while (j) {k=i/j;
                   out_byte(k+'0'); i -= k*j; j /= 10;}}

void out_string(p) char *p; {while (*p) out_byte(*p++);}

/***********************************************************************/

void ende(j,i) int j,i;

{static char *(meld[]) = {

/*  0 */ "can't open log file" ,
/*  1 */ "can't open input file" ,
/*  2 */ "Error in Quant. Table" ,
/*  3 */ "Error in Huffm. Table" ,
/*  4 */ "Error in  Frame" ,
/*  5 */ "Picture too big increase HBMP/VBMP" ,
/*  6 */ "Error in  Scan" ,
/*  7 */ "unimplemented format" ,
/*  8 */ "unexpected end of input file" ,
/*  9 */ "you never should read this" ,
/* 10 */ "you never should read this" ,
/* 11 */ "you never should read this" ,
/* 12 */ "you never should read this" ,
/* 13 */ "you never should read this" ,
};

#ifndef DEBUG
 txt = fopen("pfp.log","wb");
#else
 if (i) 
#endif
        {out_string("\15\12error: Nr.: "); out_dec(j);
         out_string(" in picture Nr.: "); out_dec(pictnr+1);
         out_string(" : ");
         out_string(meld[i]); out_string("\15\12");
        }
   
 if (jpg!=NULL) fclose(jpg);
 if (txt!=NULL) fclose(txt);
 exit(0);
}

/***********************************************************************/

